name: Publish package
on:
  push:
    branches:
      - main
  workflow_dispatch:
env:
  NPM_TAG: ${{ github.ref == 'refs/heads/main' && 'latest' || 'next' }}

# Variables reference: https://docs.github.com/en/actions/writing-workflows/choosing-what-your-workflow-does/accessing-contextual-information-about-workflow-runs#about-contexts
# Syntax reference: https://forgejo.org/docs/latest/user/actions/
jobs:
  build_and_publish:
    runs-on: docker
    steps:
      - name: Checkout repository
        uses: actions/checkout@v4
        with:
          fetch-depth: 0

      - name: Cache Bun dependencies
        id: cache
        uses: actions/cache@v4
        with:
          path: ~/.bun/install/cache
          key: ${{ runner.os }}-bun-${{ hashFiles('**/bun.lockb') }}
          restore-keys: |
            ${{ runner.os }}-bun-

      - name: Setup Bun
        id: "setup_bun"
        uses: oven-sh/setup-bun@v2

      - name: Install dependencies
        run: "bun install --production"

      - name: Bump version and publish
        uses: https://github.com/cocogitto/cocogitto-action@v3.10
        env:
          NPM_REGISTRY_TOKEN: ${{ secrets.NPM_TOKEN_FORGEJO }}
        with:
          release: true
          check-latest-tag-only: true
          git-user: 'Cog Bot'
          git-user-email: 'cog@alecodes.page'
